//=============================================================================
// file: OriginalView.h
// desc:
//		 Extends from Fl_Gl_Window to define a simple OpenGL viewport for
//		 viewing the original, unaltered image.
//=============================================================================

#ifndef __ORIGINAL_VIEW_HEADER__
#define __ORIGINAL_VIEW_HEADER__

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/gl.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "ImpressionistModel.h"

//==========[ class OriginalView ]=============================================

class OriginalView : public Fl_Gl_Window {

private:

	//---[ Model Pointer ]---------------------------------

	ImpressionistModel*		mModel;

public:
	
	//---[ Constructor ]-----------------------------------

	OriginalView( ImpressionistModel* model, int x, int y, int w, int h, const char *l);

	//---[ Draw Methods ]----------------------------------
	void draw();
	void refresh();

	//---[ Resize Method ]---------------------------------

	void resizeWindow(int width, int height);
};

#endif