//=============================================================================
// file: PaintView.h
// desc:
//		 Extends from Fl_Gl_Window to create an OpenGL viewport for viewing
//		 the altered, impressionist image being drawn by the user.  All mouse
//		 interaction for the program is handled here.
//=============================================================================

#ifndef __PAINT_VIEW_HEADER__
#define __PAINT_VIEW_HEADER__

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>

#include "ImpressionistModel.h"

//==========[ class PaintView ]================================================

class PaintView : public Fl_Gl_Window {

private:

	//---[ Model Pointer ]---------------------------------

	ImpressionistModel*		mModel;

	//---[ Cached Bitmap Location ]------------------------

	GLvoid* mPaintBitstart;

public:
	
	//---[ Constructor ]-----------------------------------

	PaintView( ImpressionistModel* model, int x, int y, int w, int h, const char *l );

	//---[ Drawing Methods ]-------------------------------

	void draw();
	void refresh();
	
	//---[ Event Handling Methods ]------------------------

	int handle(int event);
	void resizeWindow(int width, int height);

	//---[ OpenGL Buffer Methods ]-------------------------

	void saveGLBuffer();
	void restoreGLBuffer();
};

#endif